<?php

namespace Okawari\JobLogging;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\MorphTo;

/**
 * App\Models\JobLog
 *
 * @property int $id
 * @property string|null $job_id
 * @property string $class
 * @property string $name
 * @property string|null $owner_type
 * @property int|null $owner_id
 * @property bool|null $success
 * @property string $output
 * @property \Illuminate\Support\Carbon|null $started_at
 * @property \Illuminate\Support\Carbon|null $ended_at
 * @property \Illuminate\Support\Carbon|null $created_at
 * @property \Illuminate\Support\Carbon|null $updated_at
 * @property-read Model|\Eloquent $owner
 * @method static \Illuminate\Database\Eloquent\Builder|JobLog newModelQuery()
 * @method static \Illuminate\Database\Eloquent\Builder|JobLog newQuery()
 * @method static \Illuminate\Database\Eloquent\Builder|JobLog query()
 * @method static \Illuminate\Database\Eloquent\Builder|JobLog whereClass($value)
 * @method static \Illuminate\Database\Eloquent\Builder|JobLog whereCreatedAt($value)
 * @method static \Illuminate\Database\Eloquent\Builder|JobLog whereEndedAt($value)
 * @method static \Illuminate\Database\Eloquent\Builder|JobLog whereId($value)
 * @method static \Illuminate\Database\Eloquent\Builder|JobLog whereJobId($value)
 * @method static \Illuminate\Database\Eloquent\Builder|JobLog whereName($value)
 * @method static \Illuminate\Database\Eloquent\Builder|JobLog whereOutput($value)
 * @method static \Illuminate\Database\Eloquent\Builder|JobLog whereOwnerId($value)
 * @method static \Illuminate\Database\Eloquent\Builder|JobLog whereOwnerType($value)
 * @method static \Illuminate\Database\Eloquent\Builder|JobLog whereStartedAt($value)
 * @method static \Illuminate\Database\Eloquent\Builder|JobLog whereSuccess($value)
 * @method static \Illuminate\Database\Eloquent\Builder|JobLog whereUpdatedAt($value)
 * @mixin \Eloquent
 */
class JobLog extends Model
{
    use HasFactory;

    protected $casts = [
        'started_at' => 'datetime',
        'ended_at' => 'datetime',
    ];
    protected $fillable = [
        'job_id',
        'class',
        'name',
        'owner_type',
        'owner_id',
        'output',
        'started_at',
        'ended_at',
        'success'
    ];

    public function owner(): MorphTo {
        return $this->morphTo();
    }
}
